close all
clear all
clc
%some global variable for printing during optimization
global  NGRAD nnormg A  qqual Lval;
nnormg=[]; qqual=[]; Lval=[];
NGRAD=0;

%Optimization parameters
nbins=1000; % number of grid bins. (recomended for most applications 1000-10000).
lambda=1e2; % penalty for source scale.
nsrc=4; % number of signal to be separated.
T=3000; % number of signal samples.
alpha=1.06*T^(-1/5); % Kernel window bandwidth recomended: 1.06*(T-sample size)^(-1/5)*STD(signal).
maxiter=150; % bound optimization iterations number.

A=rand(nsrc);
while cond(A)>20
   A=rand(nsrc);
end
create_signals 
x=A*pic;
% the input signals should be ordered as row vectors in a (nsrc X T) matrix.
% it is recomended to subtract the mean from the signals, and divide then by their STD.

params.alpha=alpha;
params.s=x;
params.lambda=lambda;
params.bins=nbins;

W0=eye(nsrc);

%Quasi Newton algorithm 
tic
options=optimset('MaxIter',maxiter,'TolFun',1e-16,'TolX',1e-16,'Display','final','LargeScale','off', 'GradObj','on','HessUpdate','bfgs');
[W]=fminunc('fg_MI_approx',W0(:),options,params); 
toc
iter_bins=NGRAD(end)

figure ;
	subplot(311); semilogy(nnormg); title('Gradient norm'); 
    subplot(312); semilogy(qqual); title('Interf/signal ratio');
    subplot(313); plot(Lval); title('MI value'); drawnow; 
    
W=reshape(W,nsrc,nsrc); % The separation matrix
WA=W*A
quality=max(sep_quality(WA))
seperation_SNR=20*log10(1/quality)
src_est=W*x; %The reconstructed signals
std_src_est=std(src_est')